#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct {
  unsigned kn, lp;
} Uplata;

int usp_uplate(const Uplata *u1, const Uplata *u2) {
  if (u1 == u2)
    return 0;
  if (u1->kn < u2->kn)
    return -1;
  if (u2->kn < u1->kn)
    return 1;
  if (u1->lp < u2->lp)
    return -1;
  if (u2->lp < u1->lp)
    return 1;
  return 0;
}

typedef struct {
  char oib[12];
  unsigned sifra;
  Uplata uplata;
} Nalog;

int usp_naloge(const Nalog *n1, const Nalog *n2) {
  int c;
  if (n1 == n2)
    return 0;
  if (c = usp_uplate(&(n1->uplata), &(n2->uplata)))
    return c;
  c = strcmp(n1->oib, n2->oib);
  return c ? (c < 0 ? -1 : 1) : 0;
}

int nadji(FILE *f, const Uplata *u) {
  int left, right, half, c = 1;
  Nalog n;
  (void)fseek(f, 0l, SEEK_END);
  left = 0;
  right = (int)(ftell(f) / sizeof(Nalog)) - 1;
  while (left <= right) {
    half = left + (right - left) / 2;
    (void)fseek(f, half * sizeof(Nalog), SEEK_SET);
    (void)fread(&n, sizeof(Nalog), 1, f);
    c = usp_uplate(u, &(n.uplata));
    if (c < 0)
      right = half - 1;
    else if (c > 0)
      left = half + 1;
    else
      break;
  }
  if (c) {
    (void)fseek(f, 0l, SEEK_END);
    return EOF;
  }
  while (half > 0) {
    (void)fseek(f, --half * sizeof(Nalog), SEEK_SET);
    (void)fread(&n, sizeof(Nalog), 1, f);
    if (usp_uplate(u, &(n.uplata))) {
      ++half;
      break;
    }
  }
  (void)fseek(f, half * sizeof(Nalog), SEEK_SET);
  return half;
}

int sortiraj(FILE *f) {
  int len, srt, cnt = 1, end, i;
  Nalog wnd[3];
  (void)fseek(f, 0l, SEEK_END);
  len = (int)(ftell(f) / sizeof(Nalog));
  do {
    srt = 1;
    end = len - cnt;
    rewind(f);
    for (i = 0; i < end; ++i) {
      (void)fread(wnd, sizeof(Nalog), 2, f);
      if (usp_naloge(wnd + 0, wnd + 1) > 0) {
	wnd[2] = wnd[0];
	wnd[0] = wnd[1];
	wnd[1] = wnd[2];
	(void)fseek(f, -2l * sizeof(Nalog), SEEK_CUR);
	(void)fwrite(wnd, sizeof(Nalog), 2, f);
	srt = 0;
      }
      (void)fseek(f, -1l * sizeof(Nalog), SEEK_CUR);
    }
    if (srt)
      rewind(f);
    else
      ++cnt;
  } while (!srt);
  return len;
}

int main() {
  /* Napisati za DZ... */
  return EXIT_SUCCESS;
}
