#include <math.h>
#include <stdio.h>
#include <stdlib.h>

typedef struct {
  double r, h;
} Valjak;

double volumen(const Valjak *v) {
  if (!v)
    return 0.0;
  if (v->r <= 0.0)
    return 0.0;
  if (v->h <= 0.0)
    return 0.0;
  return v->r * v->r * 4.0 * atan(1.0) * v->h;
}

typedef struct {
  Valjak v;
  double m;
} Novcic;

int usp_nov(const Novcic *n1, const Novcic *n2) {
  double v1, v2;
  if (n1 == n2)
    return 0;
  v1 = volumen(&(n1->v));
  v2 = volumen(&(n2->v));
  if (v1 < v2)
    return -1;
  if (v2 < v1)
    return 1;
  if (n1->m < n2->m)
    return -1;
  if (n2->m < n1->m)
    return 1;
  return 0;
}

int nadji(FILE *f, double v) {
  int left, right, half;
  Novcic n;
  double v2 = -1.0;
  (void)fseek(f, 0l, SEEK_END);
  left = 0;
  right = (int)(ftell(f) / sizeof(Novcic)) - 1;
  while (left <= right) {
    half = left + (right - left) / 2;
    (void)fseek(f, half * sizeof(Novcic), SEEK_SET);
    (void)fread(&n, sizeof(Novcic), 1, f);
    v2 = volumen(&(n.v));
    if (v < v2)
      right = half - 1;
    else if (v2 < v)
      left = half + 1;
    else
      break;
  }
  if (v != v2) {
    (void)fseek(f, 0l, SEEK_END);
    return EOF;
  }
  while (half > 0) {
    (void)fseek(f, --half * sizeof(Novcic), SEEK_SET);
    (void)fread(&n, sizeof(Novcic), 1, f);
    if (v != volumen(&(n.v))) {
      ++half;
      break;
    }
  }
  (void)fseek(f, half * sizeof(Novcic), SEEK_SET);
  return half;
}

int sortiraj(FILE *f) {
  int len, srt, cnt = 1, end, i;
  Novcic wnd[3];
  (void)fseek(f, 0l, SEEK_END);
  len = (int)(ftell(f) / sizeof(Novcic));
  do {
    srt = 1;
    end = len - cnt;
    rewind(f);
    for (i = 0; i < end; ++i) {
      (void)fread(wnd, sizeof(Novcic), 2, f);
      if (usp_nov(wnd + 0, wnd + 1) > 0) {
	wnd[2] = wnd[0];
	wnd[0] = wnd[1];
	wnd[1] = wnd[2];
	(void)fseek(f, -2l * sizeof(Novcic), SEEK_CUR);
	(void)fwrite(wnd, sizeof(Novcic), 2, f);
	srt = 0;
      }
      (void)fseek(f, -1l * sizeof(Novcic), SEEK_CUR);
    }
    if (srt)
      rewind(f);
    else
      ++cnt;
  } while (!srt);
  return len;
}

int main() {
  /* Napisati za DZ... */
  return EXIT_SUCCESS;
}
